#!/bin/bash
# XML-generiertes SQL-Script
# von costage_prepare_unlfiles.xsl

if [ "$1" == "" ]
then
echo "Usage: costage_prepare_unlfiles.x <Delimiter> HEADER<optional>"
echo "Beispiel: costage_prepare_unlfiles.x , HEADER"
echo "Folgende Dateien können geladen werden:"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_amtstat_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_lokal_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_fachsemester_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_fakultaeten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_hauptstudien_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_hoererstatus_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_laender_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_land_regionen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_semester_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studien_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studien_spoversionen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienarten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienfaecher_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_mtsg_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienkennzahlen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienstatus_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studierendenstammdaten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbungen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbung_kombination_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_hzb_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_sb_status_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_werte_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_stat_vorl_zuordnung_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_bw_zulassungsarten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_land_subregionen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienformen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_adressen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_urlaube_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_urlaubs_typen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_abmeldungsarten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_personen_abmeldungen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_ersthochschulen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_st_hochschulsemester_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_detail_typen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_typen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_antritte_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_status_typen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/k_hzbart.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_abgeltungen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_gleichheitsknoten_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_lehrveranstaltungen_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_lv_teilnehmende_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_ergebnisse_v.csv"


echo "$COSTAGE_LOAD_PFAD/unl/px_studienplankontexte_v.csv"


fi

if [ ! -f $COSTAGE_LOAD_PFAD/superx.datum ]
then 
echo "superx.datum wird nicht übergeben"
date +'%d.%m.%Y' > $COSTAGE_LOAD_PFAD/superx.datum

fi 

if [ ! -f $COSTAGE_LOAD_PFAD/costage_unload.err ]
then 
echo "costage_unload.err wird nicht übergeben"
cat /dev/null > $COSTAGE_LOAD_PFAD/costage_unload.err
fi 

#zuerst alle Dateien nach UTF-8 konvertieren, wenn nötig:
sx_list_isofiles.x $COSTAGE_LOAD_PFAD/unl >iso.txt
sx_recode_isofiles.x iso.txt




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_amtstat_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_amtstat_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_abschlussziele_amtstat;"
DOQUERY "vacuum full costage_st_abschlussziele_amtstat;"

psql --dbname=$DBNAME -c "\copy costage_st_abschlussziele_amtstat from unl/px_st_abschlussziele_amtstat_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_abschlussziele_amtstat unl/costage_st_abschlussziele_amtstat.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_amtstat.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_amtstat.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_amtstat.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_lokal_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_abschlussziele_lokal_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_abschlussziele_lokal;"
DOQUERY "vacuum full costage_st_abschlussziele_lokal;"

psql --dbname=$DBNAME -c "\copy costage_st_abschlussziele_lokal from unl/px_st_abschlussziele_lokal_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_abschlussziele_lokal unl/costage_st_abschlussziele_lokal.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_lokal.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_lokal.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_abschlussziele_lokal.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_fachsemester_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_fachsemester_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_fachsemester;"
DOQUERY "vacuum full costage_st_fachsemester;"

psql --dbname=$DBNAME -c "\copy costage_st_fachsemester from unl/px_st_fachsemester_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_fachsemester unl/costage_st_fachsemester.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_fachsemester.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_fachsemester.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_fachsemester.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_fakultaeten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_fakultaeten_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_fakultaeten;"
DOQUERY "vacuum full costage_st_fakultaeten;"

psql --dbname=$DBNAME -c "\copy costage_st_fakultaeten from unl/px_st_fakultaeten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_fakultaeten unl/costage_st_fakultaeten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_fakultaeten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_fakultaeten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_fakultaeten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_hauptstudien_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_hauptstudien_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_hauptstudien;"
DOQUERY "vacuum full costage_st_hauptstudien;"

psql --dbname=$DBNAME -c "\copy costage_st_hauptstudien from unl/px_st_hauptstudien_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_hauptstudien unl/costage_st_hauptstudien.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_hauptstudien.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_hauptstudien.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_hauptstudien.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_hoererstatus_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_hoererstatus_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_hoererstatus;"
DOQUERY "vacuum full costage_st_hoererstatus;"

psql --dbname=$DBNAME -c "\copy costage_st_hoererstatus from unl/px_st_hoererstatus_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_hoererstatus unl/costage_st_hoererstatus.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_hoererstatus.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_hoererstatus.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_hoererstatus.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_laender_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_laender_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_laender;"
DOQUERY "vacuum full costage_st_laender;"

psql --dbname=$DBNAME -c "\copy costage_st_laender from unl/px_st_laender_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_laender unl/costage_st_laender.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_laender.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_laender.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_laender.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_land_regionen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_land_regionen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_land_regionen;"
DOQUERY "vacuum full costage_st_land_regionen;"

psql --dbname=$DBNAME -c "\copy costage_st_land_regionen from unl/px_st_land_regionen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_land_regionen unl/costage_st_land_regionen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_land_regionen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_land_regionen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_land_regionen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_semester_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_semester_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_semester_neu;"
DOQUERY "vacuum full costage_st_semester_neu;"

psql --dbname=$DBNAME -c "\copy costage_st_semester_neu from unl/px_st_semester_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_semester_neu unl/costage_st_semester.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_semester.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_semester.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_semester.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studien_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studien_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studien;"
DOQUERY "vacuum full costage_st_studien;"

psql --dbname=$DBNAME -c "\copy costage_st_studien from unl/px_st_studien_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studien unl/costage_st_studien.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studien.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studien.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studien.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studien_spoversionen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studien_spoversionen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studien_spoversionen;"
DOQUERY "vacuum full costage_st_studien_spoversionen;"

psql --dbname=$DBNAME -c "\copy costage_st_studien_spoversionen from unl/px_st_studien_spoversionen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studien_spoversionen unl/costage_st_studien_spoversionen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studien_spoversionen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studien_spoversionen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studien_spoversionen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studienarten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienarten_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studienarten;"
DOQUERY "vacuum full costage_st_studienarten;"

psql --dbname=$DBNAME -c "\copy costage_st_studienarten from unl/px_st_studienarten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studienarten unl/costage_st_studienarten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studienarten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studienarten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studienarten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studienfaecher_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienfaecher_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studienfaecher;"
DOQUERY "vacuum full costage_st_studienfaecher;"

psql --dbname=$DBNAME -c "\copy costage_st_studienfaecher from unl/px_st_studienfaecher_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studienfaecher unl/costage_st_studienfaecher.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studienfaecher.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studienfaecher.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studienfaecher.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studiengaenge_neu;"
DOQUERY "vacuum full costage_st_studiengaenge_neu;"

psql --dbname=$DBNAME -c "\copy costage_st_studiengaenge_neu from unl/px_st_studiengaenge_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studiengaenge_neu unl/costage_st_studiengaenge.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_mtsg_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studiengaenge_mtsg_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studiengaenge_mtsg;"
DOQUERY "vacuum full costage_st_studiengaenge_mtsg;"

psql --dbname=$DBNAME -c "\copy costage_st_studiengaenge_mtsg from unl/px_st_studiengaenge_mtsg_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studiengaenge_mtsg unl/costage_st_studiengaenge_mtsg.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge_mtsg.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge_mtsg.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studiengaenge_mtsg.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studienkennzahlen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienkennzahlen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studienkennzahlen_neu;"
DOQUERY "vacuum full costage_st_studienkennzahlen_neu;"

psql --dbname=$DBNAME -c "\copy costage_st_studienkennzahlen_neu from unl/px_st_studienkennzahlen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studienkennzahlen_neu unl/costage_st_studienkennzahlen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studienkennzahlen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studienkennzahlen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studienkennzahlen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studienstatus_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienstatus_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studienstatus;"
DOQUERY "vacuum full costage_st_studienstatus;"

psql --dbname=$DBNAME -c "\copy costage_st_studienstatus from unl/px_st_studienstatus_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studienstatus unl/costage_st_studienstatus.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studienstatus.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studienstatus.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studienstatus.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studierendenstammdaten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studierendenstammdaten_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studierendenstammdaten_neu;"
DOQUERY "vacuum full costage_st_studierendenstammdaten_neu;"

psql --dbname=$DBNAME -c "\copy costage_st_studierendenstammdaten_neu from unl/px_st_studierendenstammdaten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studierendenstammdaten_neu unl/costage_st_studierendenstammdaten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studierendenstammdaten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studierendenstammdaten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studierendenstammdaten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbungen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbungen_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_bewerbungen;"
DOQUERY "vacuum full costage_bw_bewerbungen;"

psql --dbname=$DBNAME -c "\copy costage_bw_bewerbungen from unl/px_bw_bewerbungen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_bewerbungen unl/costage_bw_bewerbungen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbungen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbungen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbungen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbung_kombination_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerbung_kombination_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_bewerbung_kombination;"
DOQUERY "vacuum full costage_bw_bewerbung_kombination;"

psql --dbname=$DBNAME -c "\copy costage_bw_bewerbung_kombination from unl/px_bw_bewerbung_kombination_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_bewerbung_kombination unl/costage_bw_bewerbung_kombination.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbung_kombination.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbung_kombination.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerbung_kombination.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_hzb_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_hzb_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_bewerb_hzb;"
DOQUERY "vacuum full costage_bw_bewerb_hzb;"

psql --dbname=$DBNAME -c "\copy costage_bw_bewerb_hzb from unl/px_bw_bewerb_hzb_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_bewerb_hzb unl/costage_bw_bewerb_hzb.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_hzb.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_hzb.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_hzb.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_sb_status_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_bewerb_sb_status_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_bewerb_sb_status;"
DOQUERY "vacuum full costage_bw_bewerb_sb_status;"

psql --dbname=$DBNAME -c "\copy costage_bw_bewerb_sb_status from unl/px_bw_bewerb_sb_status_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_bewerb_sb_status unl/costage_bw_bewerb_sb_status.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_sb_status.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_sb_status.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_bewerb_sb_status.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_sb_status;"
DOQUERY "vacuum full costage_bw_sb_status;"

psql --dbname=$DBNAME -c "\copy costage_bw_sb_status from unl/px_bw_sb_status_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_sb_status unl/costage_bw_sb_status.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_werte_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_status_werte_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_sb_status_werte;"
DOQUERY "vacuum full costage_bw_sb_status_werte;"

psql --dbname=$DBNAME -c "\copy costage_bw_sb_status_werte from unl/px_bw_sb_status_werte_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_sb_status_werte unl/costage_bw_sb_status_werte.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status_werte.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status_werte.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_status_werte.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_stat_vorl_zuordnung_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_sb_stat_vorl_zuordnung_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_sb_stat_vorl_zuordnung;"
DOQUERY "vacuum full costage_bw_sb_stat_vorl_zuordnung;"

psql --dbname=$DBNAME -c "\copy costage_bw_sb_stat_vorl_zuordnung from unl/px_bw_sb_stat_vorl_zuordnung_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_sb_stat_vorl_zuordnung unl/costage_bw_sb_stat_vorl_zuordnung.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_stat_vorl_zuordnung.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_stat_vorl_zuordnung.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_sb_stat_vorl_zuordnung.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_bw_zulassungsarten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_bw_zulassungsarten_v.csv wird übergeben:"

DOQUERY "truncate table costage_bw_zulassungsarten;"
DOQUERY "vacuum full costage_bw_zulassungsarten;"

psql --dbname=$DBNAME -c "\copy costage_bw_zulassungsarten from unl/px_bw_zulassungsarten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_bw_zulassungsarten unl/costage_bw_zulassungsarten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_bw_zulassungsarten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_bw_zulassungsarten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_bw_zulassungsarten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_land_subregionen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_land_subregionen_v.csv wird übergeben:"

DOQUERY "truncate table costage_land_subregionen;"
DOQUERY "vacuum full costage_land_subregionen;"

psql --dbname=$DBNAME -c "\copy costage_land_subregionen from unl/px_land_subregionen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_land_subregionen unl/costage_land_subregionen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_land_subregionen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_land_subregionen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_land_subregionen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_studienformen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_studienformen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_studienformen;"
DOQUERY "vacuum full costage_st_studienformen;"

psql --dbname=$DBNAME -c "\copy costage_st_studienformen from unl/px_st_studienformen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_studienformen unl/costage_st_studienformen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_studienformen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_studienformen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_studienformen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_adressen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_adressen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_adressen;"
DOQUERY "vacuum full costage_st_adressen;"

psql --dbname=$DBNAME -c "\copy costage_st_adressen from unl/px_st_adressen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_adressen unl/costage_st_adressen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_adressen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_adressen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_adressen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_urlaube_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_urlaube_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_urlaube;"
DOQUERY "vacuum full costage_st_urlaube;"

psql --dbname=$DBNAME -c "\copy costage_st_urlaube from unl/px_st_urlaube_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_urlaube unl/costage_st_urlaube.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaube.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaube.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaube.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_urlaubs_typen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_urlaubs_typen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_urlaubs_typen;"
DOQUERY "vacuum full costage_st_urlaubs_typen;"

psql --dbname=$DBNAME -c "\copy costage_st_urlaubs_typen from unl/px_st_urlaubs_typen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_urlaubs_typen unl/costage_st_urlaubs_typen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaubs_typen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaubs_typen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_urlaubs_typen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_abmeldungsarten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_abmeldungsarten_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_abmeldungsarten;"
DOQUERY "vacuum full costage_st_abmeldungsarten;"

psql --dbname=$DBNAME -c "\copy costage_st_abmeldungsarten from unl/px_st_abmeldungsarten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_abmeldungsarten unl/costage_st_abmeldungsarten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_abmeldungsarten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_abmeldungsarten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_abmeldungsarten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_personen_abmeldungen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_personen_abmeldungen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_personen_abmeldungen;"
DOQUERY "vacuum full costage_st_personen_abmeldungen;"

psql --dbname=$DBNAME -c "\copy costage_st_personen_abmeldungen from unl/px_st_personen_abmeldungen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_personen_abmeldungen unl/costage_st_personen_abmeldungen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_personen_abmeldungen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_personen_abmeldungen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_personen_abmeldungen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_ersthochschulen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_ersthochschulen_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_ersthochschulen;"
DOQUERY "vacuum full costage_st_ersthochschulen;"

psql --dbname=$DBNAME -c "\copy costage_st_ersthochschulen from unl/px_st_ersthochschulen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_ersthochschulen unl/costage_st_ersthochschulen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_ersthochschulen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_ersthochschulen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_ersthochschulen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_st_hochschulsemester_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_st_hochschulsemester_v.csv wird übergeben:"

DOQUERY "truncate table costage_st_hochschulsemester;"
DOQUERY "vacuum full costage_st_hochschulsemester;"

psql --dbname=$DBNAME -c "\copy costage_st_hochschulsemester from unl/px_st_hochschulsemester_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_st_hochschulsemester unl/costage_st_hochschulsemester.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_st_hochschulsemester.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_st_hochschulsemester.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_st_hochschulsemester.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_leistungen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_v.csv wird übergeben:"

DOQUERY "truncate table costage_leistungen;"
DOQUERY "vacuum full costage_leistungen;"

psql --dbname=$DBNAME -c "\copy costage_leistungen from unl/px_leistungen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_leistungen unl/costage_leistungen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_leistungen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_leistungen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_leistungen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_leistungen_detail_typen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_detail_typen_v.csv wird übergeben:"

DOQUERY "truncate table costage_leistungen_detail_typen;"
DOQUERY "vacuum full costage_leistungen_detail_typen;"

psql --dbname=$DBNAME -c "\copy costage_leistungen_detail_typen from unl/px_leistungen_detail_typen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_leistungen_detail_typen unl/costage_leistungen_detail_typen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_detail_typen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_detail_typen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_detail_typen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_leistungen_typen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_typen_v.csv wird übergeben:"

DOQUERY "truncate table costage_leistungen_typen;"
DOQUERY "vacuum full costage_leistungen_typen;"

psql --dbname=$DBNAME -c "\copy costage_leistungen_typen from unl/px_leistungen_typen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_leistungen_typen unl/costage_leistungen_typen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_typen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_typen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_typen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_antritte_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_antritte_v.csv wird übergeben:"

DOQUERY "truncate table costage_antritte;"
DOQUERY "vacuum full costage_antritte;"

psql --dbname=$DBNAME -c "\copy costage_antritte from unl/px_antritte_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_antritte unl/costage_antritte.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_antritte.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_antritte.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_antritte.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_leistungen_status_typen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_leistungen_status_typen_v.csv wird übergeben:"

DOQUERY "truncate table costage_leistungen_status_typen;"
DOQUERY "vacuum full costage_leistungen_status_typen;"

psql --dbname=$DBNAME -c "\copy costage_leistungen_status_typen from unl/px_leistungen_status_typen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_leistungen_status_typen unl/costage_leistungen_status_typen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_status_typen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_status_typen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_leistungen_status_typen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/k_hzbart.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/k_hzbart.csv wird übergeben:"

DOQUERY "truncate table costage_k_hzbart;"
DOQUERY "vacuum full costage_k_hzbart;"

psql --dbname=$DBNAME -c "\copy costage_k_hzbart from unl/k_hzbart.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_k_hzbart unl/costage_k_hzbart.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_k_hzbart.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_k_hzbart.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_k_hzbart.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_abgeltungen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_abgeltungen_v.csv wird übergeben:"

DOQUERY "truncate table costage_abgeltungen;"
DOQUERY "vacuum full costage_abgeltungen;"

psql --dbname=$DBNAME -c "\copy costage_abgeltungen from unl/px_abgeltungen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_abgeltungen unl/costage_abgeltungen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_abgeltungen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_abgeltungen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_abgeltungen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_gleichheitsknoten_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_gleichheitsknoten_v.csv wird übergeben:"

DOQUERY "truncate table costage_gleichheitsknoten;"
DOQUERY "vacuum full costage_gleichheitsknoten;"

psql --dbname=$DBNAME -c "\copy costage_gleichheitsknoten from unl/px_gleichheitsknoten_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_gleichheitsknoten unl/costage_gleichheitsknoten.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_gleichheitsknoten.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_gleichheitsknoten.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_gleichheitsknoten.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_lehrveranstaltungen_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_lehrveranstaltungen_v.csv wird übergeben:"

DOQUERY "truncate table costage_lehrveranstaltungen;"
DOQUERY "vacuum full costage_lehrveranstaltungen;"

psql --dbname=$DBNAME -c "\copy costage_lehrveranstaltungen from unl/px_lehrveranstaltungen_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_lehrveranstaltungen unl/costage_lehrveranstaltungen.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_lehrveranstaltungen.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_lehrveranstaltungen.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_lehrveranstaltungen.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_lv_teilnehmende_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_lv_teilnehmende_v.csv wird übergeben:"

DOQUERY "truncate table costage_lv_teilnehmende;"
DOQUERY "vacuum full costage_lv_teilnehmende;"

psql --dbname=$DBNAME -c "\copy costage_lv_teilnehmende from unl/px_lv_teilnehmende_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_lv_teilnehmende unl/costage_lv_teilnehmende.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_lv_teilnehmende.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_lv_teilnehmende.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_lv_teilnehmende.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_ergebnisse_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_ergebnisse_v.csv wird übergeben:"

DOQUERY "truncate table costage_ergebnisse;"
DOQUERY "vacuum full costage_ergebnisse;"

psql --dbname=$DBNAME -c "\copy costage_ergebnisse from unl/px_ergebnisse_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_ergebnisse unl/costage_ergebnisse.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_ergebnisse.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_ergebnisse.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_ergebnisse.unl"
fi




if [ -f "$COSTAGE_LOAD_PFAD/unl/px_studienplankontexte_v.csv"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/px_studienplankontexte_v.csv wird übergeben:"

DOQUERY "truncate table costage_studienplankontexte;"
DOQUERY "vacuum full costage_studienplankontexte;"

psql --dbname=$DBNAME -c "\copy costage_studienplankontexte from unl/px_studienplankontexte_v.csv using delimiters '"$1"' with null as '' CSV $2"

sx_unload_table.x costage_studienplankontexte unl/costage_studienplankontexte.unl

fi



if [ ! -f "$COSTAGE_LOAD_PFAD/unl/costage_studienplankontexte.unl"  ]
then
echo "$COSTAGE_LOAD_PFAD/unl/costage_studienplankontexte.unl wird nicht übergeben"
cat /dev/null > "$COSTAGE_LOAD_PFAD/unl/costage_studienplankontexte.unl"
fi


