#!/bin/bash
#Extraction Script for SuperX.
#Bitte nicht ändern, diese Datei ist automatisch generiert. 

SRC_PFAD=$ZUL_LOAD_PFAD
. $SUPERX_DIR/db/bin/SQL_ENV
if [ "$SRC_PFAD" = "" ]
then 
SRC_PFAD=.
fi

SX_CLIENT=jdbc
export SX_CLIENT

SOURCESYSTEM=co
export SOURCESYSTEM

if [ "$outFormat" = "" ]
then 
outFormat=txt
fi

DATUM=`cat $SRC_PFAD/superx.datum`
ERR=zul_unload.err
cp $SRC_PFAD/superx.datum $SRC_PFAD/superx.datum.alt

##Löschen der alten Dateien
rm $SRC_PFAD/unl/*unl >/dev/null 2>&1

date +'%d.%m.%Y' > $SRC_PFAD/superx.datum  ##neues Entladedatum

HEUTE=`date +'%d.%m.%Y'`

cd $SRC_PFAD >>$ERR 2>&1

echo "Letztes Update-Datum: " $DATUM >$ERR
echo "DATABASE: $DATABASE" >>$ERR
echo "VERSION:  $VERSION" >>$ERR
echo "SX_CLIENT: $SX_CLIENT" >>$ERR 
echo "1.2b^"$HEUTE"^" >$SRC_PFAD/unl/superx_unload_version.unl  

CP=".:$JDBC_CLASSPATH:$XML_CLASSPATH"


cat /dev/null >unload_params.txt

 

 
if [ "$VERSION" = "" ]
then
VERSION="13"
export VERSION
fi
echo "Parameter VERSION: $VERSION" >>$ERR
echo "\$VERSION=$VERSION" >>unload_params.txt


 
 
if [ "$EXTERNAL_SUBJECTS" = "" ]
then
EXTERNAL_SUBJECTS="false"
export EXTERNAL_SUBJECTS
fi
echo "Parameter POS_PNR: $EXTERNAL_SUBJECTS" >>$ERR
echo "\$EXTERNAL_SUBJECTS=$EXTERNAL_SUBJECTS" >>unload_params.txt


if [ "$SOURCESYSTEM" = "" ]
then
SOURCESYSTEM="co"
export SOURCESYSTEM

fi
echo "Parameter SOURCESYSTEM: $SOURCESYSTEM"  >>$ERR
echo "\$SOURCESYSTEM=$SOURCESYSTEM" >>unload_params.txt 

#jdbc zum Entladen 
if [ "$SX_CLIENT" = "jdbc" ]
then
java $JAVA_OPTS -cp $CP de.superx.bin.SxExtractor -logger:$LOGGER_PROPERTIES -dbproperties:$DB_PROPERTIES -xml:zul_costage_unload.xml -outFormat:$outFormat -delim:$DBDELIMITER -header:$header -database:$DATABASE -version:$VERSION -unload_params:unload_params.txt >>$ERR 2>&1

exit 0

fi



chmod go+r $ERR
chmod go+r $SRC_PFAD/superx.datum
chmod go+r $SRC_PFAD/superx.datum.alt
chmod go+w $SRC_PFAD/superx.datum
chmod go+w $SRC_PFAD/superx.datum.alt

chmod go+r $SRC_PFAD/unl/*

##Herstellen altes Entladedatum bei Fehler
fgrep -s "not found" $ERR >/dev/null
FLAG1=$?
fgrep -i -s "nicht gefunden" $ERR >/dev/null
FLAG2=$?
fgrep -i -s "error" $ERR >/dev/null
FLAG3=$? >/dev/null
fgrep -i -s "exception" $ERR >/dev/null 
FLAG4=$? >/dev/null

if [ $FLAG1 -eq 0 -o $FLAG2 -eq 0 -o $FLAG3 -eq 0 -o $FLAG4 -eq 0 ]
then
	echo "Fehler beim Entladen. Das Datum wird zurückgesetzt." 
	echo "---------------------------------------" 
	echo "Prüfen Sie Fehlerprotokoll: $ERR" 
	echo "---------------------------------------" 
	cp $SRC_PFAD/superx.datum.alt $SRC_PFAD/superx.datum 
fi
